#include <Arduino.h>
#include <NoDelay.h>
#include <Adafruit_NeoPixel.h>
#include <Adafruit_MPU6050.h>
#include <Adafruit_Sensor.h>
#include <Wire.h>
#include "DFRobotDFPlayerMini.h"
#include <Espalexa.h>
#ifdef ARDUINO_ARCH_ESP32
#include <WiFi.h>
#include <WebServer.h> 
#else
#include <ESP8266WiFi.h>          
#include <ESP8266WebServer.h>
#endif

#define NUMPIXELS 111




noDelay Ziebzig(500);
noDelay ViertelSekunde(250);
noDelay HalbeSekunde(750);
noDelay DreiviertelSekunde(750);
noDelay EineSekunde(1000);
noDelay HitTimer(2000);

HardwareSerial mySoftwareSerial(1);
DFRobotDFPlayerMini myDFPlayer;
Adafruit_MPU6050 mpu;



int H = 150;
int Hit;
int redColor = 0;
int greenColor = 0;
int blueColor = H;

int An = 0;

int Motor = 26;

int LED = 32;

double L = 75;
double K = (1/L);
double W = 200;

int busy = HIGH;

int buttonPin = 18;
int lastButtonState = 0;
int buttonPushCounter = 0;
int buttonState = 0;

int buttonPin1 = 19;
int buttonState1 = 0;
int lastButtonState1 = 0;
int buttonPushCounter1 = 0;

int buttonPin2 = 23;
int buttonState2 = 0;
int lastButtonState2 = 0;
int buttonPushCounter2 = 0;

int Position = 0;
int LetztePosition = 0;

unsigned long Millis;
unsigned long CurrentMillis;

unsigned long Millis1;
unsigned long CurrentMillis1;

float Gyrox;
float Gyroz;
int Gyro = 1;
int AltGyro = 0;
int HumSound = 0;
int LastHumSound = 3;
int Lautstaerke;
int LautstaerkeAlt;
int Mode = 1;
int Hum = 100;
int Move = 1;
int AltMove = 0;
int Rainbow = 0;
int Erster = 0;
int Zweiter = 0;
int Dritter = 0;
long JediAnSound;
long SithAnSound;
long JediAusSound;
long SithAusSound;
long SlowSound;
long FastSound;
long LockSound;
long Reflect;
long DarkAn;
long DarkAus;
long DarkSwing;
long DarkLoop;
long SmoothSound1;
long SmoothSound2;
long SmoothSound3;


Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, LED, NEO_GRB + NEO_KHZ800);


void setup()
{
  mySoftwareSerial.begin(9600, SERIAL_8N1, 16, 17);  // speed, type, RX, TX
  Serial.begin(115200);  
  pinMode(busy, INPUT);

  pinMode(Motor, OUTPUT);
  digitalWrite(Motor, LOW);
  pinMode(buttonPin, INPUT_PULLUP);
  pinMode(buttonPin1, INPUT_PULLUP);
  pinMode(buttonPin2, INPUT_PULLUP);
  

 
  pixels.begin();

    if (!mpu.begin()) {
    Serial.println("Failed to find MPU6050 chip");
    while (1) {
      delay(10);
    }
  }

  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    while(true);
  }
  Serial.println(F("DFPlayer Mini online."));
  
  myDFPlayer.setTimeOut(500); //Set serial communictaion time out 500ms
  myDFPlayer.volume(30);  //Set volume value (0~30).
  myDFPlayer.volumeUp(); //Volume Up
  myDFPlayer.volumeDown(); //Volume Down
  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
  myDFPlayer.outputDevice(DFPLAYER_DEVICE_SD);
  int delayms=100;

  Reflect = random(59, 82);
  myDFPlayer.playMp3Folder(Reflect);
  for (int i=NUMPIXELS; i > -1 ; i--) {
                                       pixels.setPixelColor(i, pixels.Color(0, 0, 0));
                                       pixels.show();
                                       }
                                       
}


              
                   
   
   
    
void loop()
{


  
    
  


  JediAnSound = random(1, 7);
  SithAnSound = random(7, 11);
  JediAusSound = random(11, 17);
  SithAusSound = random(17, 21);
  SlowSound = random(21, 36);
  FastSound = random(36, 51);
  LockSound = random(51, 53);
  DarkAn = random(53, 54);
  DarkAus = random(54, 55);
  DarkSwing = random(55, 59);
  Reflect = random(59, 82);
  DarkLoop = random(82, 84);
  Hum = random(84, 85);
  SmoothSound1 = random(85, 93);
  SmoothSound2 = random(185, 193);
  SmoothSound3 = random(285, 293);
      
  buttonState = digitalRead(buttonPin);
  
  if (buttonState != lastButtonState) {
                                        if (buttonState == LOW) {
                                                                  buttonPushCounter += 1;
                                                                  digitalWrite(Motor, HIGH);
                                                                  if (buttonPushCounter % 2 == 0) {
                                                                                                   if (Mode == 1) {
                                                                                                                   myDFPlayer.playMp3Folder(JediAusSound);
                                                                                                                   }
                                                                                                   if (Mode == 2) {
                                                                                                                   myDFPlayer.playMp3Folder(SithAusSound);
                                                                                                                   }
                                                                                                   if (Mode == 3) {
                                                                                                                   myDFPlayer.playMp3Folder(DarkAus);
                                                                                                                   }
                                                                                                                                                      
                                                                                                   for (int i=NUMPIXELS; i > -1 ; i--) {
                                                                                                                                        pixels.setPixelColor(i, pixels.Color(0, 0, 0));
                                                                                                                                        pixels.show();
                                                                                                                                        }
                                                                                                    An = 0;
                                                                                                    Serial.println("Aus");
                                                                                                    } else {
                                                                                                             if (Mode == 1) {
                                                                                                                             myDFPlayer.playMp3Folder(JediAnSound);
                                                                                                                             }
                                                                                                             if (Mode == 2) {
                                                                                                                             myDFPlayer.playMp3Folder(SithAnSound);
                                                                                                                             }
                                                                                                             if (Mode == 3) {
                                                                                                                             Serial.println("Darkmode on");
                                                                                                                             myDFPlayer.playMp3Folder(DarkAn);
                                                                                                                             }
                                                                                                             
                                                                                                             if (buttonPushCounter1  == 6) {
                                                                                                                                             An = 1;
                                                                                                                                             Rainbow = 1;               
                                                                                                                                           }else{
                                                                                                                                                 for (int i=0; i < NUMPIXELS; i++) {
                                                                                                                                                                                    pixels.setPixelColor(i, pixels.Color(redColor, greenColor, blueColor));
                                                                                                                                                                                    pixels.show();
                                                                                                                                                                                    }
                                                                                                                                                }                                        
                                                                                                            An = 1;
                                                                                                            
                                                                                                                                       //myDFPlayer.playMp3Folder(Hum);
                                                                                                                                      
                                                                                                            
                                                                                                            }
                                                                                                            digitalWrite(Motor, LOW);
                                                                                                            
                                                                                                            
                                                                } 
                                                                
                                      }
  lastButtonState = buttonState;

  buttonState1 = digitalRead(buttonPin1);
  if (buttonState1 != lastButtonState1) {
                                         if (buttonState1 == LOW) {
                                                                   buttonPushCounter1 += 1;
                                                                   digitalWrite(Motor, HIGH);
                                                                   if (buttonPushCounter1  == 0) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   redColor = 0;
                                                                                                   greenColor = 0;
                                                                                                   blueColor = H;
                                                                                                   Mode = 1;
                                                                                                   
                                                                                                  }
                                                                  if (buttonPushCounter1  == 1) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   redColor = 0;
                                                                                                   greenColor = H;
                                                                                                   blueColor = 0;
                                                                                                   Mode = 1;
                                                                                                 } 
                                                                  if (buttonPushCounter1  == 2) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   redColor = H;
                                                                                                   greenColor = 0;
                                                                                                   blueColor = 0;
                                                                                                   Mode = 2;
                                                                                                 }
                                                                  if (buttonPushCounter1  == 3) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   redColor = (H/2);
                                                                                                   greenColor = 0;
                                                                                                   blueColor = (H/2);
                                                                                                   Mode = 1;
                                                                                                 }
                                                                  if (buttonPushCounter1  == 4) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   redColor = (H/5);
                                                                                                   greenColor = (H/5);
                                                                                                   blueColor = (H/5);
                                                                                                   Hum = DarkLoop;
                                                                                                   Mode = 3;
                                                                                                            
                                                                                                 } 
                                                                  if (buttonPushCounter1  == 5) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   redColor = H/2;
                                                                                                   greenColor = H/2;
                                                                                                   blueColor = 0;
                                                                                                   Hum = 100;
                                                                                                   Mode = 1;
                                                                                                 }
                                                                  if (buttonPushCounter1  == 6) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   Rainbow = 1;
                                                                                                   redColor = 0;
                                                                                                   greenColor = 0;
                                                                                                   blueColor = 0;
                                                                                                   Hum = 100;
                                                                                                   Mode = 1;
                                                                                                 }
                                                                  if (buttonPushCounter1  == 7) {
                                                                                                   buttonPushCounter = 1;
                                                                                                   Rainbow = 0;
                                                                                                   redColor = 0;
                                                                                                   greenColor = 0;
                                                                                                   blueColor = H;
                                                                                                   Mode = 1;
                                                                                                   buttonPushCounter1  = 0; 
                                                                                                 }                               
                                                                  
                                                                                                             if (Mode == 1) {
                                                                                                                             myDFPlayer.playMp3Folder(JediAnSound);
                                                                                                                             }
                                                                                                             if (Mode == 2) {
                                                                                                                             myDFPlayer.playMp3Folder(SithAnSound);
                                                                                                                             }
                                                                                                             if (Mode == 3) {
                                                                                                                             myDFPlayer.playMp3Folder(DarkAn);
                                                                                                                             }  
                                                                                                
                                                                                                
                                                                  if (buttonPushCounter1  == 6) {
                                                                                                  An = 1;
                                                                                                  Rainbow = 1;               
                                                                                                 }else{
                                                                                                       for (int i=0; i < NUMPIXELS; i++) {
                                                                                                                                          pixels.setPixelColor(i, pixels.Color(redColor, greenColor, blueColor));
                                                                                                                                          pixels.show();
                                                                                                                                          An = 1;
                                                                                                                                          }
                                                                                                      
                                                                                                                                // myDFPlayer.playMp3Folder(Hum);
                                                                                                                                
                                                                                                     }
                                                                  digitalWrite(Motor, LOW);
                                                                  } 
                                                                  
                                    }
  lastButtonState1 = buttonState1;
  
  if ((Rainbow == 1)&&(An == 1)) {
                      pixels.setBrightness(50);
                       for(long firstPixelHue = 65536; firstPixelHue > 0; firstPixelHue -= 256) {
                                                                                                 
                                                                                                    for(int i=0; i<pixels.numPixels(); i++) { 
                                                                                                                                          if (buttonState1 == LOW) {
                                                                                                                                                                    //Rainbow = 0;
                                                                                                                                                                    break;
                                                                                                                                                                   }
                                                                                                                                          int pixelHue = firstPixelHue + (i * 65536L / pixels.numPixels());
                                                                                                                                          pixels.setPixelColor(i, pixels.gamma32(pixels.ColorHSV(pixelHue)));
                                                                                                                                          //pixels.show();
                                                                                                                                        }
                                                                                                  if (buttonState1 == LOW) {
                                                                                                                          //buttonPushCounter1 += 1;
                                                                                                                          //Rainbow = 0;
                                                                                                                          break;
                                                                                                                          }
                                                                                                pixels.show();
                                                                                                }
                                                                                                myDFPlayer.playMp3Folder(Hum);
                    }else{
                      pixels.setBrightness(H);
                    }
                    
                   

  buttonState2 = digitalRead(buttonPin2);
  if (buttonState2 != lastButtonState2) {
                                         if ((buttonState2 == LOW)&&(buttonPushCounter % 2 != 0)) {
                                                                                                    myDFPlayer.playMp3Folder(LockSound); 
                                                                                                    for (int i=111; i > L; i--) {
                                                                                                                                  pixels.setPixelColor(i, pixels.Color(redColor+W*(K*(i-L)), greenColor+W*(K*(i-L)), blueColor+W*(K*(i-L))));
                                                                                                                                  pixels.show();
                                                                                                                                 }
                                                                                                                                                               
                                                                                                  }  
                                       if ((buttonState2 != LOW)&&(buttonPushCounter % 2 != 0)) {
                                                                                                    myDFPlayer.playMp3Folder(Hum);
                                                                                                    for (int i=NUMPIXELS; i > L; i--) {
                                                                                                                                    pixels.setPixelColor(i, pixels.Color(redColor, greenColor, blueColor));
                                                                                                                                    pixels.show();
                                                                                                                                  }
                                                                                                 }
                                       }
                                       
  lastButtonState2 = buttonState2;
  
  sensors_event_t a, g, temp;
  mpu.getEvent(&a, &g, &temp);
  
  busy = digitalRead(14);   
  
  Gyrox = sqrt(pow((g.gyro.x), 2)); 
  Gyroz = sqrt(pow((g.gyro.z), 2));
  delay(50);
  
  if (Gyrox > Gyroz){
                      Gyro = Gyrox * 10;
                    }else{
                           Gyro = Gyroz * 10;
                         }
                               

if (Mode == 3){
                SmoothSound3 = DarkLoop;
                FastSound = DarkSwing;
                Hum = DarkLoop;
              }
  if (An == 1) {
                //Serial.println(Gyro);
                /*
                Serial.print(g.gyro.x);
                Serial.print("    ");
                Serial.println(g.gyro.z);
               */
                if (buttonState2 != LOW){
                  
                                        
                                              if (((Gyro < 5) && (abs(g.gyro.y) >= 4.3))){ 
                                                                                                              LastHumSound = 3;
                                                                                                              myDFPlayer.playMp3Folder(Reflect);
                                                                                                              digitalWrite(Motor, HIGH);
                                                                                                              Hit = random(20, 100);
                                                                                                              AltMove = 1;
                                                                                                              for ( int i=1 ; i<15 ; i++){
                                                                                                                                          pixels.setPixelColor(Hit-i, pixels.Color(H, H, H/2));
                                                                                                                                          pixels.setPixelColor(Hit, pixels.Color(H, H, H/2));
                                                                                                                                          pixels.setPixelColor(Hit+i, pixels.Color(H, H, H/2));
                                                                                                                                          pixels.show();
                                                                                                                                         }
                                                                                                              
                                                                                                              for ( int i=15 ; i>0 ; i--){
                                                                                                                                          pixels.setPixelColor(Hit-i, pixels.Color(redColor, greenColor, blueColor));
                                                                                                                                          pixels.setPixelColor(Hit, pixels.Color(redColor, greenColor, blueColor));
                                                                                                                                          pixels.setPixelColor(Hit+i, pixels.Color(redColor, greenColor, blueColor));
                                                                                                                                          pixels.show();
                                                                                                                                         }
                                                                                                              
                                                                                                              digitalWrite(Motor, LOW);
                                                                                                              myDFPlayer.playMp3Folder(Hum);
                                                                                                          }
                                                                                                          
                                                              if (Gyro != AltGyro){    
                                                                    switch (Gyro) {
                                                                                        case 0 ... 5:
                                                                                                   Move = 0;
                                                                                                   break;
                                                                                        case 10 ... 30:
                                                                                                    Move = 1;
                                                                                                    break;
                                                                                        case 40 ... 50:
                                                                                                    Move = 2;
                                                                                                    break;
                                                                                        case 60 ... 99:
                                                                                                    Move = 3;
                                                                                                    break;
                                                                                                       
                                                                                }
                                                                                AltGyro = Gyro; 
                                                              }                
                                                                        if (Move != AltMove){                            
                                                                                             switch (Move) {
                                                                                                              case 0:
                                                                                                              
                                                                                                                         Serial.println("M0");
                                                                                                                         myDFPlayer.playMp3Folder(Hum);
                                                                                                                         Erster = SmoothSound1;
                                                                                                                         Zweiter = SmoothSound1+100;
                                                                                                                         Dritter = SmoothSound1+200;
                                                                                                              
                                                                                                                         break;
                                                                                                              case 1:
                                                                                                              if(Ziebzig.update()){
                                                                                                                         Serial.println("M1");
                                                                                                                         myDFPlayer.playMp3Folder(Erster);
                                                                                                              }
                                                                                                                         break;
                                                                                                              case 2:
                                                                                                              if(Ziebzig.update()){
                                                                                                                         Serial.println("M2");
                                                                                                                         myDFPlayer.playMp3Folder(Zweiter);
                                                                                                              }
                                                                                                                         break;
                                                                                                              case 3:
                                                                                                              if(Ziebzig.update()){
                                                                                                                         Serial.println("M3");
                                                                                                                         myDFPlayer.playMp3Folder(Dritter);
                                                                                                              }
                                                                                                                         break;

                                                                                                                         
                                                                                                           }
                                                                                                           
                                                                                                           AltMove = Move; 
                                                                                                                                    
                                                                                       }             
                                                          }                               
       }                                  
               
}
